#include <iostream>
#include <stdio.h>
#include <vector>
#include <deque>
#include <time.h>
#include <algorithm>

#define pb push_back

using namespace std;

typedef vector< int > vi;
typedef unsigned long long ULL;

const int MAXN = 50 + 5;
const int MAXP = 100 + 5;

struct animalRecord {
    int index, row, col;

    animalRecord() {}
    animalRecord(int _index, int _row, int _col): index(_index), row(_row), col(_col) {}
};

struct el {
    int profit, posx, posy;

    el() {}
    el(int _profit, int _posx, int _posy): profit(_profit), posx(_posx), posy(_posy) {}
};

struct state {
    vector< vi > currentMa3x;
    int currentProfit;
    int realProfit;
    int sumOfNumbers;
    ULL used, used2;
    vector< animalRecord > list;

    state() {}
    state(vector< vi > _ma3x, int _profit, int _sum, ULL _used, vector< animalRecord > _list):
        currentMa3x(_ma3x), currentProfit(_profit), sumOfNumbers(_sum), used(_used), list(_list) {}

    void setState(vector< vi > _ma3x, int _sum) {
        currentProfit = 0;
        realProfit = 0;
        sumOfNumbers = 0;
        used = 0;
        currentMa3x = _ma3x;
        sumOfNumbers = _sum;
    }

    bool getBit(int idx) {
        if(idx < 64) return ((used >> idx) & 1);
        idx -= 64;
        return ((used2 >> idx) & 1);
    }

    void setBit(int idx) {
        if(idx < 64) used |= (1LL << idx);
        else {
            idx -= 64;
            used2 |= (1LL << idx);
        }
    }
};

int n, m, p;
vector< vi > ma3x;

int limit;

int r[MAXP], c[MAXP], k[MAXP], t[MAXP];
int ones[MAXP];
char area[MAXP][16][16];

bool used[MAXP];

deque< state > d1, d2;

int maxSafety = -1;
vector< animalRecord > answer;
vector< animalRecord > firstPart;

bool cmp(int a, int b) {
    if(ones[a] > ones[b]) return true;
    if(ones[a] < ones[b]) return false;
    if(k[a] < k[b]) return true;
    if(k[a] > k[b]) return false;
    return t[a] > t[b];
}

void read() {
    scanf("%d %d %d", &n, &m, &p);

    ma3x.resize(n);
    for(int i = 0; i < n; i ++)
        ma3x[i].resize(m);

    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            scanf("%d", &ma3x[i][j]);

    for(int i = 0; i < p; i ++) {
        scanf("%d %d %d %d\n", &r[i], &c[i], &k[i], &t[i]);
        for(int j = 0; j < r[i]; j ++)
            scanf("%s", &area[i][j]);
    }
}

void add1(state toAdd) {
    if(maxSafety < toAdd.realProfit) {
        maxSafety = toAdd.realProfit;
        answer = toAdd.list;
    }

    if(d2.empty()) {
        d2.pb(toAdd);
        return;
    }

    for(int i = 0; i < d2.size(); i ++)
        if(d2[i].currentProfit < toAdd.currentProfit ||
           (d2[i].currentProfit == toAdd.currentProfit && d2[i].realProfit < toAdd.realProfit) ||
           (d2[i].currentProfit == toAdd.currentProfit && d2[i].realProfit == toAdd.realProfit && d2[i].sumOfNumbers < toAdd.sumOfNumbers)) {
                d2.insert(d2.begin() + i, toAdd);
                break;
           }
    if(d2.size() > limit) d2.pop_back();
}

void solveGroupOne1() {
    int sum = 0;
    state tmp, nxt;

    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            sum += ma3x[i][j];

    tmp.setState(ma3x, sum);
    for(int i = 0; i < p; i ++)
        if(used[i])
            tmp.setBit(i);
    d1.pb(tmp);

    for( ; ; ) {
        if(d1.empty()) break;

        d2.clear();

        while(!d1.empty()) {
            tmp = d1[0];
            d1.pop_front();

            vi toPut;
            for(int animal = 0; animal < p; animal ++)
                if(!tmp.getBit(animal))
                    toPut.pb(animal);

            for(int iter = 0; iter < toPut.size(); iter ++)
                {
                    int animal = toPut[iter];
                    for(int x = 0; x <= n - r[animal]; x ++)
                        for(int y = 0; y <= m - c[animal]; y ++)
                        {
                            bool valid = true;

                            for(int i = 0; i < r[animal]; i ++)
                                if(valid)
                                    for(int j = 0; j < c[animal]; j ++)
                                        if(area[animal][i][j] == '1' && tmp.currentMa3x[x + i][y + j] < t[animal])
                                        {
                                            valid = false;
                                            break;
                                        }

                            if(valid)
                            {
                                nxt = tmp;
                                nxt.setBit(animal);
                                nxt.list.pb(animalRecord(animal, x, y));
                                for(int i = 0; i < r[animal]; i ++)
                                    for(int j = 0; j < c[animal]; j ++)
                                        if(area[animal][i][j] == '1')
                                        {
                                            int val = nxt.currentMa3x[x + i][y + j];
                                            nxt.currentProfit += val + (val / k[animal]);
                                            nxt.realProfit += val;
                                            nxt.sumOfNumbers -= val;
                                            val /= k[animal];
                                            nxt.currentMa3x[x + i][y + j] = val;
                                            nxt.sumOfNumbers += val;
                                        }
                                add1(nxt);
                            }
                        }
                }
        }
        d1 = d2;
    }
}

void add2(state toAdd) {
    if(maxSafety < toAdd.realProfit) {
        maxSafety = toAdd.realProfit;
        answer = toAdd.list;
    }

    if(d2.empty()) {
        d2.pb(toAdd);
        return;
    }

    for(int i = 0; i < d2.size(); i ++)
        if(d2[i].realProfit < toAdd.realProfit ||
           (d2[i].realProfit == toAdd.realProfit && d2[i].realProfit + d2[i].sumOfNumbers < toAdd.realProfit + toAdd.sumOfNumbers)) {
                d2.insert(d2.begin() + i, toAdd);
                break;
           }
    if(d2.size() > limit) d2.pop_back();
}

void solveGroupOne2() {
    d1.clear();
    d2.clear();

    for(int animal = 0; animal < p; animal ++) {
        for(int i = 0; i < r[animal]; i ++)
            for(int j = 0; j < c[animal]; j ++)
                ones[animal] += (area[animal][i][j] - '0');
    }

    state tmp, nxt;
    int sum = 0;

    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            sum += ma3x[i][j];

    tmp.setState(ma3x, sum);
    for(int i = 0; i < p; i ++)
        if(used[i])
            tmp.setBit(i);
    d1.pb(tmp);

    for( ; ; ) {
        if(d1.empty()) break;

        d2.clear();

        while(!d1.empty()) {
            tmp = d1[0];
            d1.pop_front();

            int toPut[128];
            int sz = 0;
            for(int i = 0; i < p; i ++)
                if(!tmp.getBit(i))
                    toPut[sz ++] = i;

            sort(toPut, toPut + sz, cmp);

            for(int i = 0; i < sz; i ++)
            {
                int animal = toPut[i];

                for(int x = 0; x <= n - r[animal]; x ++)
                    for(int y = 0; y <= m - c[animal]; y ++)
                    {
                        bool valid = true;

                        for(int i = 0; i < r[animal]; i ++)
                            if(valid)
                                for(int j = 0; j < c[animal]; j ++)
                                    if(area[animal][i][j] == '1' && tmp.currentMa3x[x + i][y + j] < t[animal])
                                    {
                                        valid = false;
                                        break;
                                    }

                        if(valid)
                        {
                            nxt = tmp;
                            nxt.setBit(animal);
                            nxt.list.pb(animalRecord(animal, x, y));
                            for(int i = 0; i < r[animal]; i ++)
                                for(int j = 0; j < c[animal]; j ++)
                                    if(area[animal][i][j] == '1')
                                    {
                                        int val = nxt.currentMa3x[x + i][y + j];
                                        nxt.realProfit += val;
                                        nxt.sumOfNumbers -= val;
                                        val /= k[animal];
                                        nxt.currentMa3x[x + i][y + j] = val;
                                        nxt.sumOfNumbers += val;
                                    }
                            add2(nxt);
                        }
                    }
            }
        }
        d1 = d2;
    }
}

// find where to place one animal so that the profit of the animal is maximal
// returns (maxProfit, x, y)
el chooseSingle(int animal) {
    int maxProfit = 0, x = -1, y = -1;

    for(int i = 0; i <= n - r[animal]; i ++)
        for(int j = 0; j <= m - c[animal]; j ++) {
            int curProfit = 0;
            bool valid = true;

            for(int i1 = 0; i1 < r[animal]; i1 ++)
                if(valid)
                    for(int j1 = 0; j1 < c[animal]; j1 ++)
                        if(area[animal][i1][j1] == '1') {
                            if(ma3x[i + i1][j + j1] < t[animal]) {
                                valid = false;
                                break;
                            }
                            curProfit += ma3x[i + i1][j + j1] + (ma3x[i + i1][j + j1] / k[animal]);
                        }

            if(valid && curProfit > maxProfit) {
                maxProfit = curProfit;
                x = i; y = j;
            }
        }

    return el(maxProfit, x, y);
}

// find where to place the first animal so that the profit of the next two is maximal
// returns (maxProfit - of the both animals, x, y) - where to put the first one
el chooseDouble(int animal) {
    int maxProfit = 0, x = -1, y = -1;

    for(int i = 0; i <= n - r[animal]; i ++)
        for(int j = 0; j <= m - c[animal]; j ++) {
            int curProfit = 0;
            bool valid = true;

            int cpy[16][16];

            for(int i1 = 0; i1 < r[animal]; i1 ++)
                if(valid)
                    for(int j1 = 0; j1 < c[animal]; j1 ++)
                        if(area[animal][i1][j1] == '1') {
                            if(ma3x[i + i1][j + j1] < t[animal]) {
                                valid = false;
                                break;
                            }
                            curProfit += ma3x[i + i1][j + j1] + (ma3x[i + i1][j + j1] / k[animal]);
                            cpy[i1][j1] = ma3x[i + i1][j + j1];
                        }

            if(valid) {
                for(int i1 = 0; i1 < r[animal]; i1 ++)
                    for(int j1 = 0; j1 < c[animal]; j1 ++)
                        if(area[animal][i1][j1] == '1')
                            ma3x[i + i1][j + j1] /= k[animal];

                int maxx = 0;
                for(int nextAnimal = 0; nextAnimal < p; nextAnimal ++)
                    if(!used[nextAnimal] && nextAnimal != animal) {
                        el tmp = chooseSingle(nextAnimal);
                        if(maxx < tmp.profit) maxx = tmp.profit;
                    }

                for(int i1 = 0; i1 < r[animal]; i1 ++)
                    for(int j1 = 0; j1 < c[animal]; j1 ++)
                        if(area[animal][i1][j1] == '1')
                            ma3x[i + i1][j + j1] = cpy[i1][j1];

                curProfit += maxx;

                if(curProfit > maxProfit) {
                    maxProfit = curProfit;
                    x = i; y = j;
                }
            }
        }

    return el(maxProfit, x, y);
}

void solve() {
    bool fl = false;
    if(p <= 50 && n <= 25 && m <= 25) fl = true;
    int done = 0;

    for(int iter = 0; iter < p; iter ++) {
        int chooseAnimal = -1, maxProfitOverall = -1, xOverall = -1, yOverall = -1;

        for(int animal = 0; animal < p; animal ++)
            if(!used[animal]) {
                el result;
                result = chooseSingle(animal);

                if(!result.profit) used[animal] = true;
                else if(result.profit > maxProfitOverall) {
                    chooseAnimal = animal;
                    maxProfitOverall = result.profit;
                    xOverall = result.posx;
                    yOverall = result.posy;
                }
        }

        if(chooseAnimal == -1) break;
        done ++;
        used[chooseAnimal] = true;

        firstPart.pb(animalRecord(chooseAnimal, xOverall, yOverall));
        for(int i = 0; i < r[chooseAnimal]; i ++)
            for(int j = 0; j < c[chooseAnimal]; j ++)
                if(area[chooseAnimal][i][j] == '1')
                    ma3x[xOverall + i][yOverall + j] /= k[chooseAnimal];

        if(fl && p - done <= 11) {
            limit = 60;
            solveGroupOne2();
            break;
        }
    }
}

void write() {
    for(int i = 0; i < answer.size(); i ++)
        firstPart.pb(answer[i]);

    printf("%d\n", firstPart.size());
    for(int i = 0; i < firstPart.size(); i ++)
        printf("%d %d %d\n", firstPart[i].index + 1, firstPart[i].row + 1, firstPart[i].col + 1);
}

int main()
{
    freopen("parash.in", "r", stdin);
    freopen("parash.out", "w", stdout);

    read();
    if(p <= 20 && n <= 10 && m <= 10) {
        limit = 100;
        solveGroupOne1();
        solveGroupOne2();
    }
    else solve();
    write();

    return 0;
}
